--		WWW_Cycle_Gen_Release_v01_01
--		This is my first go at something like this. 
--		A test for something a little more useful.
--		Hope there aren't too many noobee mistakes in here.


macroScript WWundaW_Cycle_Gen_v1_3 category:"WhimsyWalks Cycles"
(
	Whimsy_Array = $whimsy*

	Colour_Bg = [217, 206, 184] as color
				
try (DestroyDialog  RLT_WWW_Cycle_Gen_01) catch()
rollout RLT_WWW_Cycle_Gen_01 "The Whimsy Wunda Walker - Walk Cycles" width:350 height:604
(										--		UI
	label LB_Main_2 "Control is a Myth but let's have a go anyway." pos:[20,115] width:210 height:13
			
	GroupBox grp1 "Walk Cycle Duration" pos:[5,168] width:342 height:59
	label LB_W_C_D_01 "How many Frames from Go to Whoa?" pos:[15,183] width:177 height:13	
	spinner SPN_W_C_D "Walk Cycle Duration" pos:[20,203] width:144 height:16 range:[5,256,24] fieldwidth:35
	GroupBox grp2 "Stride Cycle" pos:[4,233] width:342 height:206
	label LB_Stride_01 "HIPS" pos:[15,253] width:25 height:13
	spinner SPN_Stride_Advance "COG Advance  " pos:[20,273] width:122 height:16 range:[-50,50,0] fieldwidth:35
	spinner SPN_Stride_Height "COG Height      " pos:[20,293] width:122 height:16 range:[-50,50,0] fieldwidth:35
	spinner SPN_Stride_Sway "Sway                " pos:[20,313] width:121 height:16 range:[-50,50,2] fieldwidth:35
	spinner SPN_Stride_Up "Up Height         " pos:[20,333] width:122 height:16 range:[0,20,1] fieldwidth:35
	spinner SPN_Stride_Dwn "Down Height    " pos:[20,353] width:121 height:16 range:[-20,0,-2] fieldwidth:35

	spinner SPN_Stride_Tilt "HipTilt               " pos:[20,373] width:120 height:16 range:[-50,50,0] fieldwidth:35
	spinner SPN_Stride_Twist "Hip Twist          " pos:[20,393] width:120 height:16 range:[-45,45,10] fieldwidth:35
	spinner SPN_Stride_Roll "Hip Roll            " pos:[20,413] width:119 height:16 range:[-45,45,5] fieldwidth:35
 			
	label LB_Stride_02 "FOOT" pos:[175,253] width:27 height:13 	
	spinner SPN_Stride_Length "Stride Length          " pos:[180,273] width:137 height:16 range:[-25,25,0] fieldwidth:35
	spinner SPN_Stride_Width "Stride Width            " pos:[180,293] width:138 height:16 range:[-20,50,0] fieldwidth:35
	spinner SPN_Stride_MidHeight "Stride Mid Height    " pos:[180,313] width:137 height:16 range:[0,50,0] fieldwidth:35
	spinner SPN_Stride_MidAdv "Stride Mid Advance" pos:[180,333] width:137 height:16 range:[-50,50,0] fieldwidth:35
	spinner SPN_Stride_MidWidth "Stride Mid Width     " pos:[180,353] width:137 height:16 range:[-50,50,0] fieldwidth:35
	spinner SPN_Foot_Splay "Foot Splay              " pos:[180,373] width:137 height:16 range:[-50,50,0] fieldwidth:35
	spinner SPN_Knee_Splay "Knee Splay              " pos:[180,393] width:137 height:16 range:[-25,25,0] fieldwidth:35
	
	GroupBox grp3 "Step Cycle" pos:[4,448] width:342 height:90
	spinner SPN_Step_Contact "Contact Angle   " pos:[20,468] width:123 height:16 range:[0,90,15] fieldwidth:35
	spinner SPN_Step_BOF "BOF Angle        " pos:[20,488] width:122 height:16 range:[0,90,35] fieldwidth:35
	spinner SPN_Step_Toe "Toe Angle        " pos:[175,468] width:120 height:16 range:[0,120,50] fieldwidth:35
	spinner SPN_Step_Toe_Drp "Toe Drop         " pos:[175,488] width:119 height:16 range:[0,50,10] fieldwidth:35
	label LB_Stride_03 "Walking on Tip Toes" pos:[20,508] width:122 height:16 
	radiobuttons RB_TipToe   labels:#("No","Yes") default:1 pos:[195,508]

	
	button BTN_Load_Rig "Load the Walker" pos:[40,135] width:95 height:21
	button BTN_Merge_Rig "Merge the Walker" pos:[210,135] width:101 height:21
	button BTN_Save "Save Settings" pos:[25,548] width:82 height:21
	button BTN_Load "Load Settings" pos:[243,548] width:81 height:21
	button BTN_Stop "Stop and Reset" pos:[130,548] width:90 height:21
	
	button BTN_Walk "One Walk Cycle - Coming right up ..." pos:[75,575] width:187 height:21
	
	HyperLink HL_Help "Help" pos:[320,5] width:150 height:20 address:(getDir #scene+ "\\Whimsy\\images\\Help_Cycles_01.htm")	--"http://area.autodesk.com/blogs/louis"
		
			
		--		saveSettings_loadSettings  --  thanks to ofer_z, who ever you may be.  http://forums.cgsociety.org/showthread.php?f=98&t=222391&highlight=save+rollout+settings
		
	local INIFilename = getDir #scene+ "\\Whimsy\\WalkerCycles.ini" -- Define a local variable for the INI file name.
		
 	fn saveSettings =
 	(
 		setINISetting INIFilename "Stride" "W_C_D" (SPN_W_C_D.value as string)
 		setINISetting INIFilename "Stride" "Advance" (SPN_Stride_Advance.value as string)
		setINISetting INIFilename "Stride" "COG Height"(SPN_Stride_Height.value as string)
		setINISetting INIFilename "Stride" "COG Tilt" (SPN_Stride_Tilt.value as string)
		setINISetting INIFilename "Stride" "Sway"(SPN_Stride_Sway.value as string)
		setINISetting INIFilename "Stride" "Up Height"(SPN_Stride_Up.value as string)
		setINISetting INIFilename "Stride" "Down Height" (SPN_Stride_Dwn.value as string)
		setINISetting INIFilename "Stride" "Twist" (SPN_Stride_Twist.value as string)
		setINISetting INIFilename "Stride" "Roll"(SPN_Stride_Roll.value as string)
		setINISetting INIFilename "Stride" "Stride Length"(SPN_Stride_Length.value as string)
		setINISetting INIFilename "Stride" "Stride Width"(SPN_Stride_Width.value as string)
		setINISetting INIFilename "Stride" "Stride Mid Height"(SPN_Stride_MidHeight.value as string)
		setINISetting INIFilename "Stride" "Stride Mid Advance"(SPN_Stride_MidAdv.value as string)
		setINISetting INIFilename "Stride" "Stride Mid Width"(SPN_Stride_MidWidth.value as string)
		setINISetting INIFilename "Stride" "Foot Splay"(SPN_Foot_Splay.value as string)
		setINISetting INIFilename "Stride" "Knee Splay"(SPN_Knee_Splay.value as string)
		setINISetting INIFilename "Step" "Contact Angle"(SPN_Step_Contact.value as string)
		setINISetting INIFilename "Step" "BOF Angle"(SPN_Step_BOF.value as string)
		setINISetting INIFilename "Step" "Toe Angle"(SPN_Step_Toe.value as string)
		setINISetting INIFilename "Step" "Toe Drop"(SPN_Step_Toe_Drp.value as string)
 	)
 	
 	fn loadSettings =
 	(
 		try(SPN_W_C_D.value = (getINISetting INIFilename "Stride" "W_C_D" ) as integer)catch()
 		try(SPN_Stride_Advance.value = (getINISetting INIFilename "Stride" "Advance") as integer)catch()
		try(SPN_Stride_Height.value = (getINISetting INIFilename "Stride" "COG Height") as integer)catch()
		try(SPN_Stride_Tilt.value = (getINISetting INIFilename "Stride" "COG Tilt") as integer)catch()
		try(SPN_Stride_Sway.value = (getINISetting INIFilename "Stride" "Sway") as integer)catch()
		try(SPN_Stride_Up.value = (getINISetting INIFilename "Stride" "Up Height") as integer)catch()
		try(SPN_Stride_Dwn.value = (getINISetting INIFilename "Stride" "Down Height") as integer)catch()
		try(SPN_Stride_Twist.value = (getINISetting INIFilename "Stride" "Twist") as integer)catch()
		try(SPN_Stride_Roll.value = (getINISetting INIFilename "Stride" "Roll") as integer)catch()
		try(SPN_Stride_Length.value = (getINISetting INIFilename "Stride" "Stride Length") as integer)catch()
		try(SPN_Stride_Width.value = (getINISetting INIFilename "Stride" "Stride Width") as integer)catch()
		try(SPN_Stride_MidHeight.value = (getINISetting INIFilename "Stride" "Stride Mid Height") as integer)catch()
		try(SPN_Stride_MidAdv.value = (getINISetting INIFilename "Stride" "Stride Mid Advance") as integer)catch()
		try(SPN_Stride_MidWidth.value = (getINISetting INIFilename "Stride" "Stride Mid Width") as integer)catch()
		try(SPN_Foot_Splay.value = (getINISetting INIFilename "Stride" "Foot Splay") as integer)catch()
		try(SPN_Knee_Splay.value = (getINISetting INIFilename "Stride" "Knee Splay") as integer)catch()SPN_Knee_Splay
		try(SPN_Step_Contact.value = (getINISetting INIFilename "Step" "Contact Angle") as integer)catch()
		try(SPN_Step_BOF.value = (getINISetting INIFilename "Step" "BOF Angle") as integer)catch()
		try(SPN_Step_Toe.value = (getINISetting INIFilename "Step" "Toe Angle") as integer)catch()
		try(SPN_Step_Toe_Drp.value = (getINISetting INIFilename "Step" "Toe Drop") as integer)catch()
		
 	)

	on BTN_Load_Rig pressed do
	(
		f = getOpenFileName caption: "Where'd ya stash the Whimsy Walker?" filename:(getDir #scene + "\\Whimsy\\") types:"Max(*.max)"
		if f == undefined then 
			(
				print "No File Chosen"; errorState = true
				messagebox "Why'd ya load the script if'n ya aint gonna run it?" title: "Whimsy Wonders Why ?"
			) 
			else 
			(
				loadMaxFile f useFileUnits:true quiet:true
			)
	)
	on BTN_Merge_Rig pressed do
	(
		messagebox  "This function has not been implemented yet." title: "Whimsy We'll_Get_Round_To_It_Dept"
-- 					f = getOpenFileName caption: "Where'd ya stash the Whimsy Walker?" filename:(getDir #scene + "\\Whimsy\\") types:"Max(*.max)"
-- 		if f == undefined then 
-- 			(
-- 				print "No File Chosen"; errorState = true
-- 				messagebox  "Why'd ya load the script if'n ya aint gonna run it?" title: "Whimsy Wonders Why ?"
-- 			) 
-- 			else 
-- 			(
-- 				mergeMaxFile f
-- 			)
	)
	on BTN_Save pressed do
		saveSettings()
	on BTN_Load pressed do
		loadSettings()
	on BTN_Stop pressed do 
		(
			stopAnimation()
			print "Whoa there Litte Buddy! :-)"
		
-- 		Whimsy_Array = $whimsy*
		for i in Whimsy_Array do 
			( 
				deletekeys i #allKeys 
				i.skinpose.assumeSkinPose()
			)
		)	
	on RLT_WWW_Cycle_Gen_01 open do
	(		
		print "Here we go again! :-)"
		stopAnimation()
		
		for i in Whimsy_Array do (i.skinpose.assumeSkinPose())
	)
	on BTN_Walk pressed do
	(
		print "... Hot and Saucy !! :-D"
		
								--		Intitialise Objects, ShortCuts and Functions
								--		Begin Step Function

fn Step t W_C_D Heel Toe BOF Contact BOF_Ang BOF_Hold Toe_Ang Toe_Drp =			--		
	(
		--		Time Definitions
		t_1a = (t + (W_C_D * 0.125))		--	at 24 FPS +3 frames		--	Weight Down_L										--	COG_DWN	--	Hips_Twist_B
		--		t												--	at 24 FPS +0 frames		--	Contact_L		--		Toe Rot_R
		t_1 = (t - (W_C_D * 0.125))			--	at 24 FPS -3 frames		--						--		Toe Rot_R		--	COG_UP	--	Hips_Roll_B	
		t_2 = (t - (W_C_D * 0.25))			--	at 24 FPS -6 frames								--		Passing_R				
		t_3 = (t - (W_C_D * 0.375))			--	at 24 FPS -9 frames		--	Toe drop_L		--		Weight Down_R	--	COG_DWN	--	Hips_Twist_A
		t_4 = (t - (W_C_D * 0.5))			--	at 24 FPS -12 frames	--	Toe Rot_L		--		Contact_R
		t_5 = (t - (W_C_D * 0.625))			--	at 24 FPS -15 frames	--	BOF Rot_L		--							--	COG_UP	--	Hips_Roll_A
		t_6 = (t - (W_C_D * 0.75))			--	at 24 FPS -18 frames	--	Passing_L								
		t_7 = (t - (W_C_D * 0.875))			--	at 24 FPS -21 frames	--	Weight Down_L	--		Toe drop_R		--	COG_DWN	--	Hips_Twist_B
		t_8 = (t - W_C_D)						--	at 24 FPS -24 frames	--	Contact_L		--		Toe Rot_R			
						
						-- 		Foot Animations
	with animate on
							-- Heel Actions
		(	
			at time t in coordsys local Heel.rotation = (angleaxis 0 [1,0,0])		--		adding 0.0 value keys
			at time t_7 in coordsys local Heel.rotation = (angleaxis 0 [1,0,0])		--		adding 0.0 value keys
			at time t_3 in coordsys local Heel.rotation = (angleaxis 0 [1,0,0])		--		adding 0.0 value keys
			at	time t_8 in coordsys local Heel.rotation = (angleaxis 0 [1,0,0])		--temp for testing

			at time t_2 in coordsys local Heel.rotation = (angleaxis Toe_Drp [1,0,0])
			at	time t_8 in coordsys local Heel.rotation = (angleaxis -Contact [1,0,0])
			at	time t in coordsys local Heel.rotation = (angleaxis -Contact [1,0,0])
		
			-- Toe Actions

			at	time t in coordsys local Toe.rotation = (angleaxis 0 [1,0,0])		--		adding 0.0 value keys
			at	time t_8 in coordsys local Toe.rotation = (angleaxis 0 [1,0,0])		--		adding 0.0 value keys
			at	time t_4 in coordsys local Toe.rotation = (angleaxis (Toe_Ang / 2) [1,0,0])		--		adding 0.0 value keys
			at	time t_3 in coordsys local Toe.rotation = (angleaxis Toe_Ang [1,0,0])

		-- 						--BOF Actions

			at	time t in coordsys local BOF.rotation = (angleaxis 0 [1,0,0])		--		adding 0.0 value keys
			at	time t_8 in coordsys local BOF.rotation = (angleaxis 0 [1,0,0])	--		adding 0.0 value keys
			at	time t_6 in coordsys local BOF.rotation = (angleaxis BOF_Hold [1,0,0])
			at	time t_4 in coordsys local BOF.rotation = (angleaxis BOF_Hold [1,0,0])		--		adding 0.0 value keys
			at	time t_3 in coordsys local BOF.rotation = (angleaxis BOF_Hold [1,0,0])	--		adding 0.0 value keys
			at	time t_4 in coordsys local BOF.rotation = (angleaxis BOF_Ang [1,0,0])
			at	time t in coordsys local BOF.rotation = (angleaxis BOF_Hold [1,0,0])		--		adding 0.0 value keys
			at	time t_8 in coordsys local BOF.rotation = (angleaxis BOF_Hold [1,0,0])
			
		)	
	)			
	-- 			
	--			Step t W_C_D Heel Toe BOF Contact BOF_Ang Toe_Ang Toe_Drp
	
												--		End Step Function					
	
													--		Begin Stride Function
	
			
		fn StrideCycle_Feet t W_C_D Foot BackTarget FrontTarget MidLift MidAdv MidWidth	=
		(
				--		Time Definitions
			
		--		t_1a = (t + (W_C_D * 0.125))		--	at 24 FPS +3 frames		--	Weight Down_L										--	COG_DWN	--	Hips_Twist_B
		--		t = W_C_D												--	at 24 FPS +0 frames		--	Contact_L		--		Toe Rot_R
				t_1 = (t - (W_C_D * 0.125))			--	at 24 FPS -3 frames		--						--		Toe Rot_R		--	COG_UP	--	Hips_Roll_B	
				t_2 = (t - (W_C_D * 0.25))			--	at 24 FPS -6 frames								--		Passing_R				
				t_3 = (t - (W_C_D * 0.375))			--	at 24 FPS -9 frames		--	Toe drop_L		--		Weight Down_R	--	COG_DWN	--	Hips_Twist_A
				t_4 = (t - (W_C_D * 0.5))			--	at 24 FPS -12 frames	--	Toe Rot_L		--		Contact_R
				t_5 = (t - (W_C_D * 0.625))			--	at 24 FPS -15 frames	--	BOF Rot_L		--							--	COG_UP	--	Hips_Roll_A
				t_6 = (t - (W_C_D * 0.75))			--	at 24 FPS -18 frames	--	Passing_L								
				t_7 = (t - (W_C_D * 0.875))			--	at 24 FPS -21 frames	--	Weight Down_L	--		Toe drop_R		--	COG_DWN	--	Hips_Twist_B
				t_8 = (t - W_C_D)						--	at 24 FPS -24 frames	--	Contact_L		--		Toe Rot_R			
				
		-- 			 -- Add Stride
				FrontTarget = FrontTarget.transform
				BackTarget = BackTarget.transform
					
					with animate on at time t in coordsys local Foot.transform = FrontTarget			--		hit that Target!
					selectKeys Foot 0
					deleteKeys Foot #selection	
					with animate on
					(
						 at time t_8 in coordsys local Foot.transform = FrontTarget
						 at time  t_3 in coordsys local Foot.transform = BackTarget				--		hit that Target!
						 at time (t - (W_C_D * 0.1875)) move Foot [-MidWidth, (MidAdv * 2), MidLift]		--		 for mid stride lift
					)
	
			)
	
	--		check to see if the Whimsy Walker rig is loaded into the scene.
			
		COG = $Whimsy_COG
		if COG == undefined do 
			(
				mergeWhimsy = queryBox  "Where's the Whimsy Walker Rig? \n Do you want to continue and \n Open the rig?" title: "Whimsy Wunda Walker"
				if mergeWhimsy then
					(
						f = getOpenFileName caption: "Where'd ya stash the Whimsy Walker?" filename:(getDir #scene + "\\Whimsy\\") types:"Max(*.max)"
						if f == undefined then 
							(
								print "No File Chosen"; errorState = true
								messagebox "Why'd ya load the script if'n ya aint gonna run it?" title: "Whimsy Wonders Why ?"
							)
							else 
							(
								loadMaxFile f
							)
						viewport.setLayout #layout_4						
						viewport.setCamera $Cam_High_Frnt
					) else 
						(
							stopAnimation()	
							destroydialog RLT_WWW_Cycle_Gen_01
							exit
						)  
			)
			
		--WhimsyRig
			
		COG = $Whimsy_COG
		COG_X = COG.pos.controller.Cycle.controller.X_Position.controller
		COG_Z = COG.pos.controller.Cycle.controller.Z_Position.controller
		COG_Home_Matrix = $Whimsy_COG_Home.transform
		
		
		Hips = $Whimsy_Hips
		Hips_Roll = Hips.rotation.controller.Rolls.controller.Y_Rotation.controller
		Hips_Twist = Hips.rotation.controller.Twists.controller.Z_Rotation.controller
		Hips_Tilt = Hips.rotation.controller.Tilt.controller.X_Rotation.controller
		Hips_Home_Matrix = $Whimsy_Hips_Home.transform
	
		
		Foot_R = $Whimsy_Foot_Pos_R
		Foot_Home_Matrix_R = $Whimsy_Foot_Pos_Home_R.transform
		Foot_Rot_R = $Whimsy_Foot_Rot_R
		Foot_Rot_Home_Matrix_R =$Whimsy_Foot_Rot_Home_R.transform
	
		Heel_Guide_R = $Whimsy_Heel_Guide_R
		Heel_Guide_Home_Matrix_R = $Whimsy_Heel_Guide_Home_R.transform
		Toe_Guide_R = $Whimsy_Toe_Guide_R
		Toe_Guide_Home_Matrix_R = $Whimsy_Toe_Guide_Home_R.transform
		BOF_Guide_R = $Whimsy_BOF_Guide_R	
		BOF_Guide_Home_Matrix_R =  $Whimsy_BOF_Guide_Home_R.transform
	-- 		Ankle_Piv_R = $Whimsy_Ankle_Pivot_R	
	
		Foot_L = $Whimsy_Foot_Pos_L
		Foot_Home_Matrix_L = $Whimsy_Foot_Pos_Home_L.transform
		
		Heel_Guide_L = $Whimsy_Heel_Guide_L
		Heel_Guide_Home_Matrix_L = $Whimsy_Heel_Guide_Home_L.transform
		Toe_Guide_L = $Whimsy_Toe_Guide_L
		Toe_Guide_Home_Matrix_L = $Whimsy_Toe_Guide_Home_L.transform
		BOF_Guide_L = $Whimsy_BOF_Guide_L	
		BOF_Guide_Home_Matrix_L =  $Whimsy_BOF_Guide_Home_L.transform
	-- 		Ankle_Piv_L = $Whimsy_Ankle_Pivot_L
				
		Target_Back_R = $Whimsy_Target_Back_R
		Target_Back_Home_Matrix_R = $Whimsy_Target_Back_Home_R.transform
		Target_Front_R = $Whimsy_Target_Front_R 
		Target_Front_Home_Matrix_R = $Whimsy_Target_Front_Home_R.transform
		Target_Back_L = $Whimsy_Target_Back_L 
		Target_Back_Home_Matrix_L = $Whimsy_Target_Back_Home_L.transform
		Target_Front_L  = $Whimsy_Target_Front_L  
		Target_Front_Home_Matrix_L = $Whimsy_Target_Front_Home_L.transform
		Driver_Targets_L_W = $Whimsy_Driver_Targets_Length_Width
		Knee_LookAt_R = $Knee_LookAt_R
		Knee_LookAt_L = $Knee_LookAt_L
		
			--		Initialise the Whimsy Walker Guides.
			
-- 		Whimsy_Array = $whimsy*
		for i in Whimsy_Array do (i.skinpose.assumeSkinPose())
		
		COG_X = COG.pos.controller.Cycle.controller.X_Position.controller
		COG_Z = COG.pos.controller.Cycle.controller.Z_Position.controller
		COG_Advance = COG.pos.controller.Active.controller.Y_Position.controller
		COG_Height = COG.pos.controller.Active.controller.Z_Position.controller
		
		--		Input Settings from User		--	Hi there! :-)
			
			
		W_C_D = SPN_W_C_D.value
		animationRange = interval 1 256 
	
			stopAnimation()
			
		print "Hang on, just a tick while I rearrange things..."
	
		--		Initialise the Whimsy Walker Guides animation.
	--Whimsy_Array = $whimsy*
		for i in Whimsy_Array do 
			( 
				deletekeys i #allKeys 
				i.skinpose.assumeSkinPose()
			)
			
			-- Set up Keys for the COG

		COG.pos.controller.Active.controller.X_Position.controller.value = 0
		COG.pos.controller.Active.controller.Y_Position.controller.value = 0
		COG.pos.controller.Active.controller.Z_Position.controller.value = 0		
	
		COG_X.value = 0
		COG_Z.value = 0
	
			-- Set up Keys for the Hips
			
		addnewkey Hips.rotation.controller.Initial.controller.X_Rotation.controller 0
		addnewkey Hips.rotation.controller.Initial.controller.Y_Rotation.controller 0
		addnewkey Hips.rotation.controller.Initial.controller.Z_Rotation.controller 0
		Hips.rotation.controller.Initial.controller.X_Rotation.controller.keys[1].value = 0.0
		Hips.rotation.controller.Initial.controller.Y_Rotation.controller.keys[1].value = 0.0
		Hips.rotation.controller.Initial.controller.Z_Rotation.controller.keys[1].value = 0.0
		addnewkey Hips_Tilt 0
		addnewkey Hips_Tilt (W_C_D / 4)
		Hips_Tilt.keys[1].value = 0
		Hips_Tilt.keys[2].value = 0
			
			
			-- Set up Keys for the Driver Targets
			
			addnewkey Driver_Targets_L_W.pos.controller.Active.controller.X_Position.controller 0
			addnewkey Driver_Targets_L_W.pos.controller.Active.controller.Y_Position.controller 0
			addnewkey Driver_Targets_L_W.rotation.controller.Active.controller.Z_Rotation.controller 0
		Driver_Targets_L_W.pos.controller.Active.controller.X_Position.controller.keys[1].value = 0		
		Driver_Targets_L_W.pos.controller.Active.controller.Y_Position.controller.keys[1].value = 0	
		Driver_Targets_L_W.rotation.controller.Active.controller.Z_Rotation.controller.keys[1].value = 0
		-- 
			-- Set up Keys for the Knees
		addnewkey Knee_LookAt_R.pos.controller.Active.controller.X_Position.controller 0
		Knee_LookAt_R.pos.controller.Active.controller.X_Position.controller.keys[1].value = 0	
		addnewkey Knee_LookAt_L.pos.controller.Active.controller.X_Position.controller 0
		Knee_LookAt_L.pos.controller.Active.controller.X_Position.controller.keys[1].value = 0	
		
		
		
		--		Create COG Animation
		
				--		Sway
					addnewkey COG_X (W_C_D - (W_C_D * 0.125))		--		t_1	
					addnewkey	COG_X(W_C_D - (W_C_D * 0.625))		--		 t_5
					addnewkey	COG_X(W_C_D - (W_C_D * 1.125))		--		 t_5
	--		Add User Values
					COG_X.keys[1].value = SPN_Stride_Sway.value 		--		SPN_Stride_Sway.value
					COG_X.keys[2].value = -SPN_Stride_Sway.value		--		SPN_Stride_Sway.value
					COG_X.keys[3].value = SPN_Stride_Sway.value		--		SPN_Stride_Sway.value
						
						-- UP_Down
					addnewkey COG_Z 0	
					addnewkey	COG_Z (W_C_D - (W_C_D * 0.5))		--		t_3
					addnewkey	COG_Z (W_C_D - (W_C_D * 0.875))		--		t_7	
	--		Add User Values
					COG_Z.keys[1].value = SPN_Stride_Up.value		--		SPN_Stride_Up.value
					COG_Z.keys[2].value = SPN_Stride_Dwn.value
					COG_Z.keys[3].value = SPN_Stride_Up.value
						
					COG_Advance.value = -SPN_Stride_Advance.value
					COG_Height.value = SPN_Stride_Height.value
						
					--		Initialise the Hips
						
			addnewkey Hips_Twist 0
			addnewkey Hips_Roll 0
			addnewkey	Hips_Twist	(W_C_D / 2)
			addnewkey	Hips_Roll	(W_C_D / 2)
						
			Hips_Tilt.keys[1].value = -SPN_Stride_Tilt.value
			Hips_Tilt.keys[2].value = SPN_Stride_Tilt.value
			
			Hips_Twist.keys[1].value = SPN_Stride_Twist.value
			Hips_Twist.keys[2].value = -SPN_Stride_Twist.value
			Hips_Roll.keys[1].value = SPN_Stride_Roll.value
			Hips_Roll.keys[2].value = -SPN_Stride_Roll.value
					
			--		Stride_Cycle
			
		Driver_Targets_L_W.pos.controller.Active.controller.Y_Position.controller.keys[1].value = SPN_Stride_Length.value
		Driver_Targets_L_W.pos.controller.Active.controller.X_Position.controller.keys[1].value = SPN_Stride_Width.value
		Driver_Targets_L_W.rotation.controller.Active.controller.Z_Rotation.controller.keys[1].value = SPN_Foot_Splay.value
		
		Knee_LookAt_R.pos.controller.Active.controller.X_Position.controller.keys[1].value = -SPN_Knee_Splay.value
		Knee_LookAt_L.pos.controller.Active.controller.X_Position.controller.keys[1].value = SPN_Knee_Splay.value
		
		MidLift = SPN_Stride_MidHeight.value
		MidAdv = -SPN_Stride_MidAdv.value
		MidWidth = SPN_Stride_MidWidth.value
	
		StrideCycle_Feet W_C_D W_C_D Foot_R Target_Back_R Target_Front_R MidLift MidAdv MidWidth
		StrideCycle_Feet W_C_D W_C_D Foot_L Target_Back_L Target_Front_L MidLift MidAdv -MidWidth
		Foot_L.pos.controller.Y_Position.controller.keys[3].time += (-MidAdv/12)
		Foot_L.pos.controller.Z_Position.controller.keys[3].time += (-MidAdv/12)
		movekeys Foot_L (W_C_D / 2)
				
	--		Step_Cycle
									-- 				
		Contact	=	SPN_Step_Contact.value		-- 						
		BOF_Ang =	SPN_Step_BOF.value
		
		if RB_TipToe.state == 1 then -- TipToe or not
			(
				BOF_Hold = 0
			)
			if RB_TipToe.state == 2 then 
			(
				BOF_Hold = (BOF_Ang / 2)
			)
		
		Toe_Ang = SPN_Step_Toe.value
		Toe_Drp	=	SPN_Step_Toe_Drp.value
	
		Step W_C_D W_C_D Heel_Guide_R Toe_Guide_R BOF_Guide_R Contact BOF_Ang BOF_Hold Toe_Ang Toe_Drp
		Step W_C_D W_C_D Heel_Guide_L Toe_Guide_L BOF_Guide_L Contact BOF_Ang BOF_Hold Toe_Ang Toe_Drp
		movekeys Heel_Guide_L (W_C_D / 2)
		movekeys Toe_Guide_L (W_C_D / 2)
		movekeys BOF_Guide_L (W_C_D / 2)
		
		
	--  And Off We go again!!
	print "And off we go again!!"
	playAnimation immediateReturn: true
	
	)
	
	

)

createdialog RLT_WWW_Cycle_Gen_01 350 620 pos:[100,100] bgcolor:Colour_Bg  bitmap: (openBitMap (getDir #scene+ "\\Whimsy\\Images\\BG_Main_Menu_01.jpg"))--fgcolor:brown	getDir #scene+ "\\Whimsy\\WalkerCycles.ini"
)